function Create(self)
    for i = 1, MovableMan:GetMOIDCount()-1, 1 do
			local gun = MovableMan:GetMOFromID(i);
			if gun.PresetName == "Particle Accelerator" then
				if SceneMan:ShortestDistance(gun.Pos,self.Pos,true).Magnitude < 50 then --math.abs(gun.Pos.X - self.Pos.X) < 50 and math.abs(gun.Pos.Y - self.Pos.Y) < 50 then
					self.gun = gun;
					self.owner = ToActor(MovableMan:GetMOFromID(gun.RootID));
				end
			end
    end

    self.bGrow = true;
    
	if self.owner ~= nil then
		--self.owner.pbc = self;
		self.checkTimer = Timer();
		self.timer = Timer();
		self.Scale = 0.1;
		self.Vel = Vector(0,0);
	else
		self:GibThis();
	end
end

function Update(self)
    if not self.owner:HasObject("Particle Accelerator") then
       self:GibThis();
    end

    if self.owner.HFlipped then
        self.AngularVel = 6;
    else
        self.AngularVel = -6;
    end

	--Checks whether the user is holding the fire button.
	if self.owner:GetController():IsState(Controller.WEAPON_FIRE) then
		--Within interval of each 100ms, grow the charge ball by +0.05 scale. Up until 1.5 is reached.
		--This is purely a special effect. A very cool effect btw.
		if self.timer:IsPastSimMS(100) then
            if self.bGrow then
               if self.Scale < 1.7 then
                  self.Scale = self.Scale + 0.05;
               else
                  self.bGrow = false;
               end
            else
               if self.Scale > 1.5 then
                  self.Scale = self.Scale - 0.05;
               else
                  self.bGrow = true;
               end
            end
            self.timer:Reset();
		end
  
		--This wtf code aligns the shot infront of the gun somehow. Srsly those Lua guys are fudge nuclear scientist.
		if self.checkTimer:IsPastSimMS(15) then
			local theta = ToActor(self.owner):GetAimAngle(true);
			self.Pos = self.gun.Pos + Vector(math.cos(theta)*40,math.sin(theta)*-40);
			
			if self.owner ~= nil then
				for actor in MovableMan.Actors do
	              if actor.ID ~= self.owner.ID then
					if SceneMan:ShortestDistance(self.Pos,actor.Pos,true).Magnitude < (10 + (self.Scale * 7.5)) and self.Scale > 0.5 then --Gives it a range from 10 to 21.75.  1.5 is the max scale.
						actor:GibThis();
					end
				  end
                end
			end
			
			--This code takes anything harmful and gravitates them at the center of the ball. 
			--Do note: it takes ANYTHING harmful, not just the deadly particles it already produces.
			local power = (50 * (2 + self.Scale));	--Has the power of pull increase as the ball grows larger.
			for particle in MovableMan.Particles do
                if particle.PresetName ~= nil then --As long as the particle exists and isn't a presumably effect particle and is not pinned nor hitmos = 0.
                   local distVec = SceneMan:ShortestDistance(particle.Pos,self.Pos,true);
                   if distVec.Magnitude < power then
                        if particle.HitsMOs then
                            if particle.Sharpness < 10 then --Most bullets are above 10 on sharpness.  This prevents bullet immunity.
							    particle.HitsMOs = false;
                            end
                        end
                        --local distVec = SceneMan:ShortestDistance(particle.Pos,self.Pos,true); ,--Makes a new vector of the difference in position between the orb and the affected particle
						particle.Vel = particle.Vel + distVec:SetMagnitude(distVec.Magnitude/50); --Add the above defined vector divided by 50 to the particle's velocity, propelling it in the orb's direction.
					end
				end
				
			end
			
		--end	
			self.checkTimer:Reset();
		end
	else
		--self.owner.pbc = nil;
		local power = (80 * (2+self.Scale)); --(100 * (2 + self.Scale))
		for particle in MovableMan.Particles do
			local distVec = SceneMan:ShortestDistance(self.Pos,particle.Pos,true); -- self.Pos - particle.Pos;
			if distVec.Magnitude < power then
               if not particle.HitsMOs then
                   particle.HitsMOs = true;
               end
                particle:SetWhichMOToNotHit(self.owner,1);
				if not(self.owner:GetController():IsState(Controller.WEAPON_FIRE)) then
				particle.ToDelete = true;
				particle.LifeTime = 0;
				end
			end
		end
		self:GibThis();
    end
end
